// ===========================================================================================================
// RankingHandler.lua
//
// To handle User ranking and country ranking by parse cloud code for iOS and Android
//
// Version 1.0
//
// Developed by: Qasim Farooqi (Swenggco Software)
// ===========================================================================================================


var _CountryRankClassName = "CountryRank";
var _countryName = "countryName";
var _countryCumulativeScore = "cumulativeScore";


exports.getClassData = function(user, className, limit, sortedBy, options) {

    var classObject = Parse.Object.extend(className);
    var classObjectQuery = new Parse.Query(classObject);
    classObjectQuery.descending(_countryCumulativeScore);
    classObjectQuery.limit(limit);
//    classObjectQuery.equalTo(_countryName, user.get(_countryName));
    mainQuery.find({
        success: function(results) {
            // results is an array of Parse.Object.
            console.log("results.." + results.length);
            console.log(results);
            options.success(results);
        },
        error: options.error});
};

_createNewCountryRank = function(countryName, cumulativeScore, options, countryRankObject) {
    console.log("_createNewCountryRank...");
    var countryRank = countryRankObject;
    if (!countryRank) {
        countryRank = new (Parse.Object.extend(_CountryRankClassName))();
        countryRank.set(_countryName, countryName);
    }
    countryRank.set(_countryCumulativeScore, cumulativeScore);
    countryRank.save(null, {
        success: function(savedCountryRank) {
            console.log("countryRank country saved successfully.");
            options.success(true);
        },
        error: function(error) {
            console.log("countryRank country not saved.error is below.");
            console.log(error);
            options.error(false);
        }
    });

};


exports._updateCountryRank = function(countryName, playerScore, options) {

    console.log("_updateCountryRank...countryName" + countryName + " playerScore" + playerScore);
    var countryRank = Parse.Object.extend("CountryRank");
    var countryRankQuery = new Parse.Query(countryRank);
    countryRankQuery.count({
        success: function(number) {
            console.log("number");
            console.log(number);
            if (number == 0) {
                _createNewCountryRank(countryName, playerScore, options, null);
            } else {
                var newCountryRankQuery = new Parse.Query(countryRank);
                newCountryRankQuery.equalTo(_countryName, countryName);
                newCountryRankQuery.find({
                    success: function(objects) {
                        console.log("objects.length" + objects.length);
                        if (objects.length == 1) {
                            console.log("newCountryRankQuery country found successfully.");
                            var userCountry = objects[0];
                            var oldCumulativeScore = userCountry.get(_countryCumulativeScore);
                            var newCumulativeScore = oldCumulativeScore + playerScore;
                            _createNewCountryRank(countryName, newCumulativeScore, options, userCountry);
                        } else {
                            if (objects.length == 0) {
                                _createNewCountryRank(countryName, playerScore, options, null);
                            } else {
                                console.log("objects.length in else" + objects.length);
                                console.log("newCountryRankQuery country found multiple times.");
                            }

                        }
                    },
                    error: function(error) {
                        console.log("newCountryRankQuery country not found. error is below.");
                        console.log(error);
                        options.error(false);
                    }
                });
            }
        },
        error: function(error) {
            console.log("error");
            console.log(error);
        }
    });

};


