var GameManager = require('cloud/game_matchingold.js');

Parse.Cloud.define("getClassData", function(request, response) {
    var user = request.params.user;
    var className = request.params.className;
    var limit = request.params.limit;
    var sortedBy = request.params.sortedBy;
    console.log("getClassData for  user " + user + " class name:" + className + " limit:" + limit + " sortedBy:" + sortedBy);
    if (user && className && limit && sortedBy) {
        GameManager.getClassData(user,className,limit,sortedBy, {
            success: function(res) {
                response.success(res);
            },
            error: function(error) {
                console.log("An error has occurred during getClassData.");
                response.error(error);
            }
        });
    } else {
        console.log("user && className && limit && sortedBy all are one of them is miss.");
        response.error("user && className && limit && sortedBy all are one of them is miss.");
    }

});

Parse.Cloud.define("getMatch", function(request, response) {
    var user = request.params.user;
    var matchId = request.params.matchId;
    console.log("getMatch for  user " + user);
    GameManager.getMatch(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during getMyMatches.");
            response.error(error);
        }
    });

});


Parse.Cloud.define("testPush", function(request, response) {
    var user = request.params.user;
    var customValue = request.params.customValue;
    console.log("testPush for  user " + user);
    GameManager.testPush(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during getMyMatches.");
            response.error(error);
        }
    });

});


Parse.Cloud.define("signOutUser", function(request, response) {
    var user = request.user;
    if (user) {
        console.log("signOutUser for  user " + user);
        GameManager.signOutUser(request, {
            success: function(res) {
                response.success(res);
            },
            error: function(error) {
                console.log("An error has occurred during signOutUser.");
                response.error(error);
            }
        });
    } else {
        console.log("Authentication failed.");
        response.error("Authentication failed");
    }
});



Parse.Cloud.define("getMyMatches", function(request, response) {
    var user = request.params.user;
    console.log("getMyMatches for  user " + user);
    GameManager.getMyMatches(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during getMyMatches.");
            response.error(error);
        }
    });

});



Parse.Cloud.define("searchUser", function(request, response) {
    var searchQuery = request.params.searchQuery;
    console.log("searchUser for  searchQuery " + searchQuery);
    GameManager.searchUser(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during searchUser.");
            response.error(error);
        }
    });

});


Parse.Cloud.define("getMyFriends", function(request, response) {

    console.log("getMyFriend request from " + request.user);
    GameManager.getMyFriends(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during addFriend.");
            response.error(error);
        }
    });

});




Parse.Cloud.define("getFiveQuestions", function(request, response) {
//    var category = request.params.category;
//    console.log("getFiveQuestions request for  category id" + category);
    GameManager.getFiveQuestions(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during getFiveQuestions.");
            response.error(error);
        }
    });

});


Parse.Cloud.define("addFriend", function(request, response) {
    var friendId = request.params.friendId;
    console.log("addFriend request for  friend id" + friendId);
    GameManager.addFriend(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during addFriend.");
            response.error(error);
        }
    });

});


Parse.Cloud.define("deleteFriend", function(request, response) {
    var friendId = request.params.friendId;
    console.log("deleteFriend request for  friend id" + friendId);
    GameManager.deleteFriend(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during deleteFriend.");
            response.error(error);
        }
    });

});




Parse.Cloud.define("setMyScore", function(request, response) {
    var matchId = request.params.matchId;
    console.log("setMyScore request for  match id" + matchId);
    GameManager.setMyScore(request, {
        success: function(res) {
            response.success(res);
        },
        error: function(error) {
            console.log("An error has occurred during setMyScore.");
            response.error(error);
        }
    });

});




Parse.Cloud.define("joinChallengeMatch", function(request, response) {
    console.log("Incoming join request from " + request.user);
    var matchId = request.params.matchId
//   var towerData=request.params.towerData
    if (request.user) {
        if (matchId) {
            GameManager.joinMatch(request, {
                success: function(match) {
                    response.success(match);
                },
                error: function(error) {
                    console.log(error);
                    response.error("An error has occurred.");
                }
            });
        } else {
            response.error("matchId is missing.");
        }
    } else {
        response.error("Authentication failed");
    }
});


Parse.Cloud.define("createChallengeMatch", function(request, response) {
    console.log("Incoming createChallengeMatch request from " + request.user);
    var player2id = request.params.player2Id;
    var categoryName = "Questions";//request.params.categoryName
    console.log("player2id :"+player2id);
    if (request.user) {
        if (player2id) {
            GameManager.rematch(request.user, player2id, categoryName, {
                success: function(match, isTurn) {
                    response.success(match);
                },
                error: function(error) {
                    console.log("An error has occurred, in createChallengeMatch");
                    response.error(error);
                }
            });
        } else {
            response.error("player2id is missing.");
        }
    } else {
        response.error("Authentication failed");
    }
});



Parse.Cloud.afterSave("Match", function(request) {
    console.log("match afterSave called.");
});



Parse.Cloud.define("joinRandomNewGame", function(request, response) {
    console.log("Incoming join request from " + request.user);
    _handleRandomGameRequest(request, response);

});




_handleRandomGameRequest = function(request, response) {

    console.log("_handleRandomGameRequest ");
    if (request.user) {
        var category="Questions"//request.params.categoryName;
        if (category) {
            GameManager.joinAnonymousGame(request, {
                success: function(match, isTurn) {
                    response.success(match);
                },
                error: function(error) {
                    if (error == "notfind") {
                        response.error("notfind.");
                    } else {
                        console.log(error);
                        response.error("An error has occurred.");
                    }
                }
            });
        } else if (request.params.matchId) {
            GameManager.matchJoined(request.params.matchId, {
                success: function(match, isTurn) {
                    response.success(match);
                },
                error: function(error) {
                    console.log(error);
                    response.error("An error has occurred at match found.");
                }
            });
        } else {
            response.error("categoryName missing.");
        }
    } else {
        response.error("Authentication failed");
    }

}




// matchOrDelete 
Parse.Cloud.define("matchOrDelete", function(request, response) {

    var matchId = request.params.matchId
    console.log("matchOrDelete in main id is" + matchId);

    GameManager.matchOrDelete(matchId, {
        success: function(result) {
            console.log("result:" + result);
            response.success(result);

        },
        error: function(error) {
            if (error == true) {
                response.error("Match already removed or not exist.");
            } else {
                console.log(error);
                response.error("An error has occured.");
            }
        }
    });
}
);





// delete match
Parse.Cloud.define("deleteMatch", function(request, response) {

    var matchId = request.params.matchId
    console.log("deleteMatch in main id is" + matchId);

    GameManager.deleteMatch(request, {
        success: function(result) {
            console.log("result:" + result);
            response.success(result);

        },
        error: function(error) {
            console.log("Match already removed or not exist.");
            response.error(error);
        }
    });
}
);

