// ===========================================================================================================
// PushHandler.lua
//
// To handle push notification sending by parse cloud code on iOS and Android
//
// Version 1.0
//
// Developed by: Qasim Farooqi (Swenggco Software)
// ===========================================================================================================



exports.testPush = function(request, options) {

    _sendPushAndroid(request.params.deviceId, request.params.message, request.params.customValue, options);

};


_sendPushAndroid = function(userDeviceId, message, customValues) {//options


    var myMessage = (message ? message : "testing push notification on Android");

    var urlGCM = "https://android.googleapis.com/gcm/send";
    var header = {
        'Authorization': 'key=' + 'AIzaSyAiT3aMjikRIH8G6yBsuD7WXd03euK4J7g',
        'Content-Type': 'application/json;charset=utf-8'
    };
    Parse.Cloud.httpRequest({
        method: 'POST',
        url: urlGCM, //'https://android.googleapis.com/gcm/send',
        headers: header,
        body: {
            registration_ids: [userDeviceId],
            data: {
                // Put something here
                alert: myMessage,
                sound: "notification.wav",
                custom: (customValues ? customValues : [])
            }
        },
        success: function(httpResponse) {
            // Do something
            console.log(httpResponse.text);
//     options.success("notification is send...")
        },
        error: function(httpResponse) {
            console.error('GCM Request failed' + JSON.stringify(httpResponse));
// 	options.error(httpResponse)
        }
    });
};





exports._sendPush = function(player, message, matchValues) {//player is push receiver and matchValues cantains the custom data and conditions
    console.log("sending push");
    console.log(matchValues);

    if (!player) {
        console.log("push receiver is not valid...");
    } else {

        if (player.get("userDevice") == "android" && player.get("deviceToken") != null) {
            console.log("user is on android...");
            _sendPushAndroid(player.get("deviceToken"), message, matchValues);
        } else {

            console.log(" player.installationId");
            console.log(player.get("installationId"));

            var query = new Parse.Query(Parse.Installation);
            query.equalTo("objectId", player.get("installationId"));
            query.equalTo("pushId", player.id);
// 	query.equalTo("deviceType", "ios");

            Parse.Push.send({
                where: query,
                //   expiration_time: new Date(),
                expiration_interval: 3600,
                data: {
                    alert: message,
                    badge: "Increment",
                    title: "Game invitation",
                    custom: (matchValues ? matchValues : []),
                }
            },
            {success: function() {
                    console.log("notification is send");
                }, error: function(err) {
                    console.log(err);
                }
            });
        }//end of player.get()== "android"

    }//end of !player
};