// ===========================================================================================================
// HandleCategories.js
//
// To handle User ranking to every category by parse cloud code for iOS and Android
//
// Version 1.0
//
// Developed by: Qasim Farooqi (Swenggco Software)
// ===========================================================================================================

var _UserID = "UserId";
var _CategoryNameToCategoryClassName={IPL:"IPLRank",ODI:"ODIRank",T20:"T20Rank",Test:"TestRank"};
var _countryCumulativeScore = "cumulativeScore";


exports.getClassData = function(user, className, limit, sortedBy, options) {

    var classObject = Parse.Object.extend(_CategoryNameToCategoryClassName[className]);
    var classObjectQuery = new Parse.Query(classObject);
    classObjectQuery.descending(_countryCumulativeScore);
    classObjectQuery.limit(limit);
//    classObjectQuery.equalTo(_countryName, user.get(_countryName));
    mainQuery.find({
        success: function(results) {
            // results is an array of Parse.Object.
            console.log("results.." + results.length);
            console.log(results);
            options.success(results);
        },
        error: options.error});
};

_createNewCategoryRank = function(categoryName, cumulativeScore, userId, options, categoryRankObject) {
    console.log("_createNewCategoryRank...");
    var categoryRank = categoryRankObject;
    if (!categoryRank) {
        categoryRank = new (Parse.Object.extend(_CategoryNameToCategoryClassName[categoryName]))();
        categoryRank.set(_UserID, userId);
    }
    categoryRank.set(_countryCumulativeScore, cumulativeScore);
    categoryRank.save(null, {
        success: function(savedcategoryRank) {
            console.log("categoryRank category saved successfully.");
            options.success(true);
        },
        error: function(error) {
            console.log("categoryRank category not saved.error is below.");
            console.log(error);
            options.error(false);
        }
    });

};


exports._updateCategoryRank = function(categoryName, playerScore, userId, matchCategory, options) {

    console.log("_updateCategoryRank...categoryName" + categoryName + " playerScore" + playerScore + " matchCategory " + matchCategory);
    var categoryRank = Parse.Object.extend(_CategoryNameToCategoryClassName[categoryName]);
    var categoryRankQuery = new Parse.Query(categoryRank);
    categoryRankQuery.count({
        success: function(number) {
            console.log("number");
            console.log(number);
            if (number == 0) {
                _createNewCategoryRank(categoryName, playerScore, userId, options, null);
            } else {
                var newCategoryRankQuery = new Parse.Query(categoryRank);
                newCategoryRankQuery.equalTo(_UserID, userId);
                newCategoryRankQuery.find({
                    success: function(objects) {
                        console.log("objects.length" + objects.length);
                        if (objects.length == 1) {
                            console.log("newCategoryRankQuery category found successfully.");
                            var userCategory = objects[0];
                            var newCumulativeScore = 0;
                            if (matchCategory == "Questions") {
                                var oldCumulativeScore = userCategory.get(_countryCumulativeScore);
                                newCumulativeScore = oldCumulativeScore + playerScore;
                            } else {
                                var oldCumulativeScoreOfMatchCategory = userCategory.get(_countryCumulativeScore);
                                if (!oldCumulativeScoreOfMatchCategory) {
                                    oldCumulativeScoreOfMatchCategory = 0;
                                }
                                newCumulativeScore = oldCumulativeScoreOfMatchCategory + playerScore;
                            }
                            _createNewCategoryRank(categoryName, newCumulativeScore, userId, options, userCategory);
                        } else {
                            if (objects.length == 0) {
                                _createNewCategoryRank(categoryName, playerScore, userId, options, null);
                            } else {
                                console.log("objects.length in else" + objects.length);
                                console.log("newCategoryRankQuery category found multiple times.");
                            }
                        }
                    },
                    error: function(error) {
                        console.log("newCategoryRankQuery category not found. error is below.");
                        console.log(error);
                        options.error(false);
                    }
                });
            }
        },
        error: function(error) {
            console.log("error");
            console.log(error);
        }
    });

};


